# -*- coding: utf-8 -*-
from zope import schema
from zope.interface import implementer

from plone.autoform.directives import order_after, omitted

from Products.Poi import PoiMessageFactory as _
from Products.Poi.content.tracker import possibleAssignees
from Products.Poi.content.issue import IIssue as IIssueOrig
from Products.Poi.content.issue import Issue as IssueOrig


class IIssue(IIssueOrig):
    """Customization of marker interface for Poi issue"""

    assignee = schema.Choice(
        title=_(u'Poi_label_issue_assignee', default=u'Ticket owner'),
        description=_(u'Poi_help_issue_assignee',
                      default=u"Select the user responsible "
                      u"for issue management."),
        source=possibleAssignees,
        required=False,
    )

    # order things the way we want them
    order_after(subject='IRequestedBy.requested_by')
    order_after(watchers='IRequestedBy.requested_by')
    order_after(assignee='IRequestedBy.requested_by')
    order_after(contact_email='related_issue')
    order_after(target_release='related_issue')
    order_after(severity='related_issue')
    order_after(issue_type='related_issue')
    order_after(area='related_issue')


@implementer(IIssue)
class Issue(IssueOrig):
    """
    An issue in the Poi Tracker
    """